/***********************************************************************************************

      File: 
     Title: APT Automatic Parallelizing Tool
    Author: Nils Schmeisser
   Version: 1.0
  Rev.Date: 20.2.1996

   Comment: 

***********************************************************************************************/

#ifndef APT_
  #define APT_

  #include <stdio.h>

  // source language
  
  #define LANGUAGE         0x0fe
  #define C_LANGUAGE       0
  #define FORTRAN_LANGUAGE 2
  #define PASCAL_LANGUAGE  4
  #define ASM_LANGUAGE     6

  // standard file suffixes

  extern const char srcsuffix[4][4];

  // target platform

  #define TARGET           1
  #define UNIX_TARGET      0
  #define DOS_TARGET       1
  #define OS2_TARGET       2

  // parallelization modes

  #define ALL_MODE   0
  #define LOOP_MODE  1
  #define BLOCK_MODE 2

  extern FILE *apt_profile;
  extern char *apt_title;
  extern char *apt_version;
  extern char *apt_copyright;

  extern int FORTRAN_FORMAT_MARK;
  extern int SOURCE,PLATFORM;
  extern int PMODE;
  extern int NMODULES;
  extern char **MODULES;
  extern char *MAINMODULE;

  extern int APTProfilerInit(int argc,char **argv);
  extern int APTProfilerDone();
  extern void APTProfilerError(char *emsg);
  extern void APTDepCheckerError(char *emsg);

#endif
