/***********************************************************************************************

      File: 
     Title: APT Automatic Parallelizing Tool
    Author: Nils Schmeisser
   Version: 1.0
  Rev.Date: 20.2.1996

   Comment: 

***********************************************************************************************/

#ifndef PARALLEL_
  #define PARALLEL

  #define NO_PROF_CINFO 0
  #define PROFILING     1
  #define NO_CODE_INFO  2

  #define CODE_STATEMENT 0
  #define CODE_SEQUENCE  1
  #define CODE_LOOP      2
  #define CODE_PROCEDURE 3
  #define CODE_FUNCTION  4

  //--- Search Item Constants

  #define SAND     1
  #define SOR      2

  //--- maximum number of node dependencies

  #define MAXDEPNODES 1024

  //--- maximum number of in/output variables

  #define MAXDEPVARS 1024

  typedef struct {
    int type;
    char *name;
    char *modname;
    char *code;
    unsigned long int line1,line2;
    unsigned long int time;
    int ninput;
    char **input;
    int noutput;
    char **output;
    unsigned int npred,nsucc;
    void **pred,**succ;
    int root;
    int node;
    unsigned int nsyncs;
    int *syncs;
  } codeinfostruct;

  typedef struct {
    codeinfostruct *item;
    void *next;
  } ciliststruct;

  typedef struct {
    char *module;
    unsigned long int line1,line2;
    void *next;
  } blockliststruct;

  extern ciliststruct *CODEINFO;
  extern blockliststruct *BLOCKS;

  extern void InitDepChecker();
  extern codeinfostruct *GenerateCodeInfo(char *code,
					  char *modname,unsigned long line1,unsigned long line2,
					  unsigned long *count,int type,int profiling,FILE *f);
  extern void BuildDependencies(ciliststruct *cl);
  extern int Pred(codeinfostruct *s1,codeinfostruct *s2);
#endif


