%{
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "cppmacro.h"

#define MAXIDENTS 256
#define MAXLENGTH 1024

char ibuffer[1024];
char libuffer[1024];
int ibcnt;
char **output;
char **input;
int ninput;
int noutput;

%}

%start stat
%token LETTER CHAR DIGIT
%left '|'
%left '&'
%left '+' '-'
%left '*' '/' '%'
%left UMINUS

%%
stat:   assign ';' ;
ifstat: 'if' expr stat | 'if' expr stat 'else' stat
assign: lident '=' expr { 
          output[noutput]=new(char,strlen(libuffer)+1);
	  strcpy(output[noutput],libuffer);
          noutput++;
	};
expr:   '(' expr ')'
     | expr '+' expr
     | expr '-' expr
     | expr '*' expr
     | expr '/' expr
     | expr '%' expr
     | expr '&' expr
     | expr '|' expr
     | '-' expr %prec UMINUS
     | ident { 
         input[ninput]=new(char,strlen(ibuffer)+1);
	 strcpy(input[ninput],ibuffer);
	 ninput++;
       }
     | number;
lident: ident { 
          sprintf(libuffer,"%s",ibuffer);
	};
ident:  LETTER {
          ibcnt=0;
          ibuffer[ibcnt]=$1;
	  ibcnt++;
	  ibuffer[ibcnt]=0;
        } 
      | ident LETTER {
          ibuffer[ibcnt]=$2;
	  ibcnt++;
	  ibuffer[ibcnt]=0;
        } 
      | ident number {
	  char nbuffer[1024];
	  int i;

          sprintf(nbuffer,"%d",$2);
	  for (i=0;i<strlen(nbuffer);i++) {
	    ibuffer[ibcnt]=nbuffer[i];
	    ibcnt++;
	  }
	  ibuffer[ibcnt]=0;
        };
number: DIGIT {
          $$=$1;
        }
        | number DIGIT {
	  $$=10*$1+$2;
        };
%%

char *code=NULL;
char *cptr;
int l;

yylex() {
  char c;

  while ((*cptr==' ') && (*cptr!=0) && (l<MAXLENGTH)) {
    cptr++;
    l++;
  }
  c=*cptr;
  cptr++;
  l++;
  if ((c!=0) && (l<=MAXLENGTH)) {
    if ((c>='a') && (c<='z')) {
      yylval=c;
      return LETTER;
    } else if ((c>='A') && (c<='Z')) {
      yylval=c;
      return LETTER;
    } else if ((c>='0') && (c<='9')) {
      yylval=c-'0';
      return DIGIT;
    }
    return c;
  }
  return c;
}

void yyerror(char *s) {
  printf("%s\n",s);
}

int ParseLine_C(char *code_,char **input_,int *ninput_,char **output_,int *noutput_) {

  code=code_;
  cptr=code;
  output=output_;
  input=input_;
  ninput=0;
  noutput=0;
  if (!yyparse()) {
    *ninput_ =ninput;
    *noutput_=noutput;
    return 1;
  } else
    return 0;
}



