/***********************************************************************************************

      File: profiler.c
     Title: APT Automatic Parallelizing Tool
    Author: Nils Schmeisser
   Version: 1.0
  Rev.Date: 20.2.1996

   Comment: This is the profiler module

            global variables in profile source code:

                  C-Language:  clock_t apt_prof_time_1,apt_prof_time_2,apt_difftime;
                               FILE *apt_profile;
	    FORTRAN-Language:  REAL APT_PROF_TIME_1(2),APT_PROF_TIME_2(2)
	                       INTEGER APT_PROFILE
                               Marke mit FORMAT Anweisung, muss dynamisch erzeugt werden.

                               FORTRAN_FORMAT_MARK   FORMAT(f10.4)   

***********************************************************************************************/

#include <stdio.h>
#include <string.h>
#include <apt.h>

void gettime(FILE *f,int number) {
  char s[512];

  if (TARGET==UNIX_TARGET) {
    switch (SOURCE) {
      case C_LANGUAGE:       sprintf(s,"apt_prof_time_%d=clock();\n",number);
                             break;
      case FORTRAN_LANGUAGE: sprintf(s,"      CALL DTIME(APT_PROF_TIME)\n");
                             break;
      case PASCAL_LANGUAGE:  sprintf(s,"\n",number);
                             break;
      case ASM_LANGUAGE:     sprintf(s,"{ sorry, don not know how to estimate user time}\n",number);
                             break;
    }
  } else {
    switch (SOURCE) {
      case C_LANGUAGE:       sprintf(s,"apt_prof_time_%d=clock();\n",number);
                             break;
      case FORTRAN_LANGUAGE: sprintf(s,"      CALL DTIME(APT_PROF_TIME)\n");
                             break;
      case PASCAL_LANGUAGE:  sprintf(s,"{ sorry, don not know how to estimate user time}\n",number);
                             break;
    }
  }
  fprintf(f,"%s",s);
}

void gettime1(FILE *f) { gettime(f,1); }
void gettime2(FILE *f) { gettime(f,2); }

void difftime(FILE *f,char *modname,char *name) {
  char s[1024];

  if ((PLATFORM)==UNIX_TARGET) {
    switch (SOURCE) {
      case C_LANGUAGE:       sprintf(s,"apt_difftime=apt_prof_time_2-apt_prof_time_1;\n");
	                     sprintf(s,"%sfprintf(apt_profile,\"%s@%s: %%d\\n\",apt_difftime);\n",
				     s,name,modname);
                             break;
      case FORTRAN_LANGUAGE: sprintf(s,"      CALL APTPROFILERWRITE(APT_PROF_TIME,'%s',%d,'%s',%d)\n",
				     name,strlen(name),modname,strlen(modname));
                             break;
      case PASCAL_LANGUAGE:  sprintf(s,"{ sorry, don not know how to estimate user time}\n");
                             break;
    }
  } else {
    switch (SOURCE) {
      case C_LANGUAGE:       sprintf(s,"apt_difftime=apt_prof_time_2-apt_prof_time_1;\n");
	                     sprintf(s,"%sfprintf(apt_profile,\"%s@%s: %%d\\n\",apt_difftime);\n",
				     s,name,modname);
                             break;
      case FORTRAN_LANGUAGE: sprintf(s,"      CALL APTPROFILERWRITE(APT_PROF_TIME,'%s','%s')\n",
				     name,modname);
                             break;
      case PASCAL_LANGUAGE:  sprintf(s,"{ sorry, don not know how to estimate user time}\n");
                             break;
    }
  }
  fprintf(f,"%s",s);
}







